/* This is an example program to demonstrate help_to_man. */

#include <stdio.h>
#include <string.h>
#include <libgen.h>

// Configuration section - note that config changes are automatically reflected in the man page.
#define ANSWER	42
#define TODAY	__DATE__

void printhelp(char *argv0){
	printf( "This is an example to demonstrate the use of help_to_man. It's really useful for a program to\n"
		"print out detailed help with -h, especially because the program can adjust its help text to\n"
		"the environment, and print out compile-time settings. Furthermore, if the documentation resides\n"
		"within the program, it is more likely to be updated in sync with changes to the program.\n"
		"\n"
		"However, man pages are still the most helpful and widely used format. The trick is to keep the two\n"
		"in sync; this is what help_to_man does. So the documentation is dynamically constructed at build-time.\n"
		"\n"
		"USAGE:    %s   OPTIONS\n"
		"\n"
		"OPTIONS:  -h           show this help.\n"
		"\n" 
		"          -d           debug  (not actually implemented in this example).\n"
		"\n"
		"          -a           print the ultimate answer (typically %d).\n"
		"\n"
		"          -v           verbose\n"
		"\n"
		"          -n  NUM      repeat NUM times.\n"
		"\n"
		"          -x           Overwrite without confirmation.\n"
		"\n"
		"RETURNS:\n"
		"          0            on success.\n"
		"          1            on error.\n"
		"\n"
		"NOTES:    * This was compiled on %s\n"
		"          * This is an example program, it doesn't actually do anything.\n"
		"\n",
		basename(argv0), ANSWER, TODAY);
}

int main (int argc, char *argv[]){
	if ((argc == 2) && !strcmp (argv[1], "-h")){
		printhelp(argv[0]);
	}else{
		printf ("A real program would do something useful here...\n");
	}
	return (0);
}
